Summary:        Simple Web Indexing System for Humans - Enhanced
Name:           swish-e
Version:        2.4.7
Release:        1.ru
License:        GPlv2+ with exceptions
Group:          Applications/Internet
Source:         http://swish-e.org/distribution/%{name}-%{version}.tar.gz
# Rutgers patch
Patch0:         mailman-swish.cgi.patch
URL:            http://swish-e.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  libxml2-devel
BuildRequires:  pcre-devel
BuildRequires:  zlib-devel
BuildRequires:  perl(ExtUtils::MakeMaker)


%description
Swish-e is Simple Web Indexing System for Humans - Enhanced

Swish-e can quickly and easily index directories of files or remote 
web sites and search the generated indexes.

Swish-e is extremely fast in both indexing and searching, highly
configurable, and can be seamlessly integrated with existing web sites
to maintain a consistent design. Swish-e can index web pages, but can
just as easily index text files, mailing list archives, or data stored
in a relational database.

%package        perl
Summary:        Perl Scripts and Modules
Group:          Applications/Internet
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-perl-api = %{version}-%{release}

%description    perl
PERL SWISH-E language bindings and scripts.


%package	perl-api
summary:	Perl interface to the Swish-e C Library
License:	Perl License
Group:		Development/Libraries
Provides:	perl-SWISH-API = 0.04
Requires:	%{name} = %{version}-%{release}
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description	perl-api
SWISH::API provides a Perl interface to the Swish-e search engine.
SWISH::API allows embedding the swish-e search code into your application
avoiding the need to fork to run the swish-e binary and to keep an index file
open when running multiple queries.  This results in increased search performance.


%package	devel
Summary:	Libraries and header files.
Group:		Development/Libraries
Requires:	pkgconfig
Requires:	%{name} = %{version}-%{release}

%description	devel
Libraries and header files required for compiling applications based on the SWISH-E API.


%prep
%setup -q
pushd example
%patch0 -p0
popd

%build
%configure \
   --disable-static \
   --with-pcre \
   --libexecdir=%{_libexecdir}/swish-e

make %{?_smp_mflags}

# Make SWISH::API
cp %{_builddir}/%{name}-%{version}/swish-config %{_builddir}/%{name}-%{version}/src/
chmod +x %{_builddir}/%{name}-%{version}/src/swish-config
pushd perl
   grep -rsl '^#!.*perl' . |
   grep -v '.bak$' |xargs --no-run-if-empty \
   perl -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)'

   CFLAGS="%{optflags}" SWISHBIN="%{_builddir}/%{name}-%{version}/src/swish-e" SWISHBINDIR="%{_builddir}/%{name}-%{version}/src" \
      perl Makefile.PL \
      `perl -MExtUtils::MakeMaker -e ' print qq|PREFIX=%{buildroot}%{_prefix}| if \$ExtUtils::MakeMaker::VERSION =~ /5\.9[1-6]|6\.0[0-5]/ '` 

   make PREFIX=%{buildroot}%{_prefix} LIB='%{_libdir}' LIBS='-L%{_libdir} -L%{buildroot}/src/.libs -lswish-e -lz' \
      'LDFLAGS=-L%{_libdir} -L%{_builddir}/%{name}-%{version}/src/.libs' 'CCFLAGS=-I%{_builddir}/%{name}-%{version}/src' \
      'LDDLFLAGS=-shared -L%{_builddir}/%{name}-%{version}/src/.libs/ -lswish-e'
popd

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} sysconfdir=%{_sysconfdir} install

# Install SWISH::API
pushd perl
   make install `perl -MExtUtils::MakeMaker -e ' print \$ExtUtils::MakeMaker::VERSION <= 6.05 ? qq|PREFIX=%{buildroot}%{_prefix}| : qq|DESTDIR=%{buildroot}| '`

   # remove special files
   find %{buildroot} -name "perllocal.pod" \
       -o -name ".packlist"                \
       -o -name "*.bs"                     \
       |xargs -i rm -f {}
popd

# fix permissions
find %{buildroot} | xargs -i chmod u+w {}

# no empty directories
find %{buildroot}%{_prefix}             \
    -type d -depth                      \
    -exec rmdir {} \; 2>/dev/null

# kill .la files
rm -f %{buildroot}%{_libdir}/*.la

# Move docdir to the proper place
mv %{buildroot}%{_docdir}/swish-e %{buildroot}%{_docdir}/swish-e-devel-%{version}

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%check
pushd tests
   make test
popd

%files
%defattr(-, root, root,-)
%doc COPYING
%{_bindir}/swish-e
%{_libdir}/*.so.*
%{_mandir}/man[^3]/*

%files perl
%defattr(-, root, root,-)
%{_bindir}/swish-filter-test
%{_libexecdir}/swish-e/
%{_datadir}/swish-e/

%files perl-api
%defattr(-,root,root,-)
%doc perl/Changes perl/README
%{perl_sitearch}/SWISH/
%{perl_sitearch}/auto/
%{_mandir}/man3/SWISH::API.3pm*

%files devel
%defattr(-, root, root,-)
%{_docdir}/swish-e-devel-%{version}/
#%{_mandir}/man3/*.3*
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_bindir}/swish-config

%changelog
* Wed Mar 24 2010 Orcan Ogetbil <orcan@nbcs.rutgers.edu> - 2.4.7-1.ru
- CentOS port. Specfile originates from upstream tarball

* Sun Dec 07 2008 Josh Rabinowitz <joshr> 2.5.6-6
- fix Source link to tarball, bump release to 6
* Thu Dec 13 2007 David L Norris <dave@webaugur.com> 2.5.6
- Lots of changes to make Fedora happy.
- Remove SUSE specific stuff.
- Change SWISH::API License to same as perl.
- Changed main license to match http://fedoraproject.org/wiki/Licensing
* Fri Apr 08 2005 Bernhard Weisshuhn <bkw@weisshuhn.de> 2.4.3-5
- Differentiate between libdir and libexecdir (for x86_64)
- Use swish-config from builddir for perl-build (pretty crude)
- remove buildroot prior to install
- Added pkgconfig and swish-config to devel package
* Sun Nov 07 2004 David L Norris <dave@webaugur.com> 2.5.2-4
- Simplify File::Find script.  Merge HTML docs with swish-e package.
* Sun Nov 07 2004 David L Norris <dave@webaugur.com> 2.5.2-3
- Fix dependencies so SWISH::API requires the correct version of SWISH-E.
* Sun Nov 07 2004 David L Norris <dave@webaugur.com> 2.5.2-2
- Incorporate File::Find script written by Peter Karman <karman@cray.com>
* Sat Nov 06 2004 David L Norris <dave@webaugur.com> 2.5.2-1
- Fix SWISH::API build so it compiles without libswish-e being installed.
* Sat Oct 23 2004 David L Norris <dave@webaugur.com> 2.5.2-0
- Add SWISH::API support. Based roughly on spec from Bernhard Weisshuhn <bkw@weisshuhn.de>.
* Sun Jul 11 2004 David L Norris <dave@webaugur.com> 2.5.1
- Made spec a little more generic.
* Fri Oct 24 2003 David L Norris <dave@webaugur.com> 2.4.0-pr4-0
- Added new files and moved extra documentation and examples to a separate package.
* Mon Jun 30 2003 David L Norris <dave@webaugur.com> 2.4.0-pr1-1cefha
- Modified spec file to minimize dependences on CEFHA.org server.
* Thu Jun 19 2003 David L Norris <dave@webaugur.com> 2.4.0-pr1
- Updated RPM spec to provide recently added files
* Sun Apr 20 2003 David L Norris <dave@webaugur.com> 2.3.5
- Updated RPM to provide the SWISH-E helper scripts.
* Fri Mar 28 2003 David L Norris <dave@webaugur.com> 2.3.5
- Updated RPM for the new libtool-based 2.3.5 build system.
* Wed Dec 04 2002 David L Norris <dave@webaugur.com> 2.3-dev04
- Created RPM spec file
